/* platform_lnx.h
 *
 *   LUNAR - Lightweight Underlay Network Ad hoc Routing
 *
 *   header file with LINUX specific definitions
 *
 * Copyright (C) 2001-2004 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 */

#ifndef PLATFORM_LNX_H
#define PLATFORM_LNX_H

#define MODULE
#ifdef CONFIG_MODVERSIONS
#  define MODVERSIONS
#  include <linux/modversions.h>
#endif

#include <linux/config.h>
#include <linux/module.h>
// ----------------------------------------------------------------------


#ifndef MODULE_LICENSE
# define MODULE_LICENSE(s)  typedef char dummy782378273
#endif

#include <linux/kernel.h>
#include <linux/init.h>

#include <asm/byteorder.h>
#include <asm/bitops.h>
#include <linux/version.h>
#include <linux/ctype.h>


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,10)

void __bug(const char *file, int line, void *data){
  printk("bug: %s %d\n", file, line);
}

#define _set_bit_le    ___set_bit_le
#define _clear_bit_le  ___clear_bit_le

__inline__ __const__ __u16 __fswab16(__u16 x) {
	return (x << 8) | ((x >> 8) & 0x0ff);
}

__inline__ __const__ __u32 __fswab32(__u32 x) {
	return
		(((__u32)x & (__u32)0x000000ffUL) << 24) |
		(((__u32)x & (__u32)0x0000ff00UL) <<  8) |
		(((__u32)x & (__u32)0x00ff0000UL) >>  8) |
		(((__u32)x & (__u32)0xff000000UL) >> 24) ;
}

__inline__ __const__ __u64 __fswab64(__u64 x) {
	return
                (((__u64)x & (__u64)0x00000000000000ffULL) << 56) |
                (((__u64)x & (__u64)0x000000000000ff00ULL) << 40) |
                (((__u64)x & (__u64)0x0000000000ff0000ULL) << 24) |
                (((__u64)x & (__u64)0x00000000ff000000ULL) <<  8) |
                (((__u64)x & (__u64)0x000000ff00000000ULL) >>  8) |
                (((__u64)x & (__u64)0x0000ff0000000000ULL) >> 24) |
                (((__u64)x & (__u64)0x00ff000000000000ULL) >> 40) |
                (((__u64)x & (__u64)0xff00000000000000ULL) >> 56) ;
}

#endif

// ----------------------------------------------------------------------

#include <linux/errno.h>
#include <linux/types.h>
#include <linux/socket.h>
#include <linux/proc_fs.h>
#include <linux/random.h>
#include <linux/timer.h>

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/inetdevice.h>
#include <linux/in.h>

// #include <net/checksum.h>
#include <linux/ip.h>
#include <linux/udp.h>

#include <linux/in6.h>
#include <asm/uaccess.h>
#include <asm/checksum.h>

// ----------------------------------------------------------------------

inline unsigned char getRandomByte()
{
	unsigned char b;

	get_random_bytes(&b, 1);
	return b;
}

# define const64(x) (x##LL)
# define const64u(x) (x##ULL)

#define DEBUG(l,s) {if((l)<=debuglevel){s;}}
static int debuglevel = 0;

#endif // PLATFORM_LNX_H
