/*Header file for class SAPF*/
#ifndef _SAPF_NS_H
#define _SAPF_NS_H


/*=======================================================================
  TIMERS
========================================================================*/
class SAPF;

class SAPFTimer : public TimerHandler {
 public:
  SAPFTimer(SAPF *a);//:TimerHandler(){a_=a; debuglevel=debug}
  double expires;
  int debuglevel;
 protected:
  virtual void expire (Event *e);
  SAPF *a_;
};

//---------------------------------------------------------------------------


class SAPF

{
 public:
  SAPF(SELNET *);

  //sapf declarations
#include "../include/sapf_decl.h"

  sapfsel_t random;
  inline unsigned char getRandomByte()
    {
      sapfsel_t b;
      
      get_random_bytes(&b, 1);
      return (unsigned char)(0x0ff & b);
    };
	int debuglevel;
  
 private:

      	/*SAPF logic public methods*/
	int sel2hash(int handle, sapfsel_t s);
	int sel2ndx(int handle, sapfsel_t s);// return ndx of matching entry or -1
	int sel2EmptyNdx(int handle, sapfsel_t s);
	int freeEntry(int handle, int i); // mark this entry as deleted, release aux memory
	void selRandomize(sapfsel_t *sel);
	

	//TIMER funcs redefinition
	void add_timer (SAPFTimer *);
	void del_timer (SAPFTimer *);

	//random func redefinition
	void get_random_bytes(sapfsel_t *, int );




	//struct timer_list sapf_gc_timer;
	SAPFTimer sapf_gc_timer;


	SELNET *selnet_;


};

#endif //SAPF_NS_H
